/*  : 131000 - 132000.     31.12.2020 07:24:07. */
SET TERM !! ;

CREATE PROCEDURE ImportDocType (
   ID_               INTEGER,
   PROGINDEX_        INTEGER,
   NAME_             VARCHAR(255),
   USESTATE_         INTEGER,
   DBTABLE_          VARCHAR(255),
   NEEDEDS_          INTEGER,
   LOCKMASK_         INTEGER,
   DEFAULTACTIONMACROSNAME_ VARCHAR(255),
   DOCUMENTKIND_     INTEGER,
   SHORTNAME_         VARCHAR(255)
) AS
DECLARE VARIABLE IDExists INTEGER;
BEGIN
   SELECT COUNT (ID)
     FROM DocumentTypes
    WHERE (ID = :ID_)
     INTO :IDExists;

   IF (:IDExists = 0) THEN
      INSERT INTO DocumentTypes
                  (ID, PROGINDEX, NAME, USESTATE, DBTABLE, NEEDEDS, LOCKMASK, DEFAULTACTIONMACROSNAME, DOCUMENTKIND,SHORTNAME)
           VALUES (:ID_, :PROGINDEX_, :NAME_, :USESTATE_, :DBTABLE_, :NEEDEDS_, :LOCKMASK_, :DEFAULTACTIONMACROSNAME_, :DOCUMENTKIND_, :SHORTNAME_);
    else
      Update documenttypes set
        Name=:Name_,
        DBTABLE=:DBTABLE_,
        LockMask=:LockMask_,
        DEFAULTACTIONMACROSNAME=:DEFAULTACTIONMACROSNAME_,
        DOCUMENTKIND = :DOCUMENTKIND_,
        SHORTNAME = :SHORTNAME_,
        PROGINDEX = :PROGINDEX_
      where (id=:ID_)
        and (
          (Name<>:Name_) or 
          ((LockMask is null) and (:LOCKMASK_ is not null)) or
          ((LockMask is not null) and (:LOCKMASK_ is null)) or
          ((LockMask is not null) and (:LOCKMASK_ is not null) and (LockMask <> :LOCKMASK_)) or
          (DEFAULTACTIONMACROSNAME is null) or
          (DOCUMENTKIND<>:DOCUMENTKIND_) or 
          (SHORTNAME is null) or 
          (SHORTNAME<>:SHORTNAME_) OR 
          (PROGINDEX <> :PROGINDEX_) OR
          ((DBTABLE is null) and (:DBTABLE_ is not null)) or
          ((DBTABLE is not null) and (:DBTABLE_ is null)) or
          ((DBTABLE is not null) and (:DBTABLE_ is not null) and (DBTABLE <> :DBTABLE_))
        );          
END
!!

CREATE PROCEDURE UPDATEINTERFACES (
  CLS_   INTEGER,
  NOTE_  VARCHAR(255),
  GUID_  VARCHAR(50),
  PARAM_ VARCHAR(255)
) AS
DECLARE VARIABLE IDExists INTEGER;
BEGIN
  SELECT COUNT (ID)
    FROM INTERFACES
  WHERE 
   (GUID=:GUID_)
   INTO :IDEXISTS;
  
  IF (:IDExists = 0)  THEN
  BEGIN
    IF (:PARAM_ = '') THEN PARAM_ = NULL;
    INSERT INTO INTERFACES
      (CLS,NOTE,GUID,PARAM)
    VALUES
      (:CLS_,:NOTE_,:GUID_,:PARAM_);  
  END
  ELSE
  BEGIN
    IF ((:PARAM_ = '')OR((:PARAM_ IS NULL))) THEN 
    UPDATE INTERFACES SET
      CLS = :CLS_
    WHERE (GUID=:GUID_) AND ((CLS<> :CLS_)OR(CLS IS NULL));
    ELSE 
    UPDATE INTERFACES SET
      CLS = :CLS_
    WHERE (GUID=:GUID_) AND (PARAM=:PARAM_) AND ((CLS<> :CLS_)OR(CLS IS NULL));
  END  
END
!!

/*    */

EXECUTE PROCEDURE ImportDocType(216, 280, '   ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') !!
EXECUTE PROCEDURE ImportDocType(217, 281, '   ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') !!



DROP PROCEDURE ImportDocType !!

DROP PROCEDURE UPDATEINTERFACES !!





CREATE PROCEDURE ImportDocCLS (
   ID_                 INTEGER,
   DOCTYPE_            INTEGER,
   DOCTYPENOTE_        VARCHAR(255),
   TABLENAME_          VARCHAR(30),
   TABLENAMEURM_       VARCHAR(30),
   PRIMARYKEYNAME_     VARCHAR(255),
   PRIMARYKEYNAMEURM_  VARCHAR(255),
   LINKFIELDNAME_      VARCHAR(255),
   LINKFIELDNAMEURM_   VARCHAR(255),
   CLSTYPE_            INTEGER,
   SELECTIONREFBUDGET_ INTEGER,
   SELECTIONREFURM_    INTEGER,
   PROGINDEX_          INTEGER    
) AS
DECLARE VARIABLE IDExists INTEGER;
BEGIN
   SELECT COUNT (ID)
   FROM DOCUMENTCLS
   WHERE (ID = :ID_)
   INTO :IDExists;
   IF (:IDExists = 0) THEN
   INSERT INTO DOCUMENTCLS
   (ID, DOCTYPE, DOCTYPENOTE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM, LINKFIELDNAME, LINKFIELDNAMEURM, 
     CLSTYPE, SELECTIONREFBUDGET, SELECTIONREFURM, PROGINDEX)
   VALUES (:ID_, :DOCTYPE_, :DOCTYPENOTE_, :TABLENAME_, :TABLENAMEURM_, :PRIMARYKEYNAME_, :PRIMARYKEYNAMEURM_, :LINKFIELDNAME_, :LINKFIELDNAMEURM_, 
     :CLSTYPE_, :SELECTIONREFBUDGET_, :SELECTIONREFURM_, :PROGINDEX_);
   ELSE
   UPDATE DOCUMENTCLS 
   SET
     DOCTYPENOTE = :DOCTYPENOTE_,
     TABLENAME = :TABLENAME_,
     TABLENAMEURM = :TABLENAMEURM_,
     PRIMARYKEYNAME = :PRIMARYKEYNAME_,
     PRIMARYKEYNAMEURM = :PRIMARYKEYNAMEURM_,
     LINKFIELDNAME = :LINKFIELDNAME_,
     LINKFIELDNAMEURM = :LINKFIELDNAMEURM_,
     CLSTYPE = :CLSTYPE_,
     SELECTIONREFBUDGET = :SELECTIONREFBUDGET_,
     SELECTIONREFURM = :SELECTIONREFURM_,
     PROGINDEX = :PROGINDEX_
   WHERE  
    (ID = :ID_)
    AND NOT (
            (
                    ((DOCTYPENOTE IS NOT NULL AND :DOCTYPENOTE_ IS NOT NULL) AND
                       (UPPER (DOCTYPENOTE) = UPPER (:DOCTYPENOTE_))
                    )
                    OR (DOCTYPENOTE IS NULL AND :DOCTYPENOTE_ IS NULL)
                )    
        AND (UPPER (TABLENAME) = UPPER (:TABLENAME_))    
        AND (
                    ((TABLENAMEURM IS NOT NULL AND :TABLENAMEURM_ IS NOT NULL) AND
                       (UPPER (TABLENAMEURM) = UPPER (:TABLENAMEURM_))
                    )
                    OR (TABLENAMEURM IS NULL AND :TABLENAMEURM_ IS NULL)
                )    
        AND (UPPER (PRIMARYKEYNAME) = UPPER (:PRIMARYKEYNAME_))
        AND (
                    ((PRIMARYKEYNAMEURM IS NOT NULL AND :PRIMARYKEYNAMEURM_ IS NOT NULL) AND
                       (UPPER (PRIMARYKEYNAMEURM) = UPPER (:PRIMARYKEYNAMEURM_))
                    )
                    OR (PRIMARYKEYNAMEURM IS NULL AND :PRIMARYKEYNAMEURM_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAME IS NOT NULL AND :LINKFIELDNAME_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAME) = UPPER (:LINKFIELDNAME_))
                    )
                    OR (LINKFIELDNAME IS NULL AND :LINKFIELDNAME_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAMEURM IS NOT NULL AND :LINKFIELDNAMEURM_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAMEURM) = UPPER (:LINKFIELDNAMEURM_))
                    )
                    OR (LINKFIELDNAMEURM IS NULL AND :LINKFIELDNAMEURM_ IS NULL)
                )    
        AND (
                    ((CLSTYPE IS NOT NULL AND :CLSTYPE_ IS NOT NULL) AND
                       (UPPER (CLSTYPE) = UPPER (:CLSTYPE_))
                    )
                    OR (CLSTYPE IS NULL AND :CLSTYPE_ IS NULL)
                ) 
        AND (
                    ((PROGINDEX IS NOT NULL AND :PROGINDEX_ IS NOT NULL) AND
                       (PROGINDEX = :PROGINDEX_)
                    )
                    OR (PROGINDEX IS NULL AND :PROGINDEX_ IS NULL)
                )    
            );
END
!!

/*    */



EXECUTE PROCEDURE ImportDocCLS(21600, 216, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 280) !!
EXECUTE PROCEDURE ImportDocCLS(21601, 216, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 280) !!
EXECUTE PROCEDURE ImportDocCLS(21700, 217, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 281) !!
EXECUTE PROCEDURE ImportDocCLS(21701, 217, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 281) !!
EXECUTE PROCEDURE ImportDocCLS(21702, 217, '2', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 281) !!

DROP PROCEDURE ImportDocCLS
!!

COMMIT WORK!!

CREATE PROCEDURE ImportField (
   ID_                INTEGER,
   NAME_              VARCHAR(255),
   ITFFIELDNAME_      VARCHAR(255),
   NOTE_              VARCHAR(255),
   TEMPLATEFIELD_     VARCHAR(255),
   ISBUDGET_          INTEGER,
   DOCTYPEREF_        INTEGER,
   DETAILNUMBER_      INTEGER,
   ONLYREAD_          INTEGER,
   ReportFieldName_   VARCHAR(255),
   KIND_          INTEGER,
   FIELDINFOREF_      INTEGER,
   CONTAINERREF_      INTEGER,
   ATTRFIELDKIND_     INTEGER,
   ATTRIBUTENAME_     VARCHAR(255)                    
) AS
DECLARE VARIABLE IDExists INTEGER;
DECLARE VARIABLE FieldID  INTEGER;
BEGIN
   SELECT COUNT (ID)
     FROM DocumentFields
    WHERE (ID = :ID_)
     INTO :IDExists;

   IF (:IDExists <> 0) THEN
      UPDATE DocumentFields
         SET NAME = :NAME_,
             ITFFIELDNAME = :ITFFIELDNAME_,
             NOTE = :NOTE_,
             TEMPLATEFIELD = :TEMPLATEFIELD_,
             ISBUDGET = :ISBUDGET_,
             DOCTYPEREF = :DOCTYPEREF_,
             DETAILNUMBER = :DETAILNUMBER_,
             ONLYREAD = :ONLYREAD_,
             ReportFieldName = :ReportFieldName_,
             FIELDINFOREF = :FIELDINFOREF_,
             CONTAINERREF = :CONTAINERREF_,
             ATTRFIELDKIND = :ATTRFIELDKIND_,
             ATTRIBUTENAME = :ATTRIBUTENAME_
       WHERE (ID = :ID_)
         AND NOT (
                      (
                          (
                           (NAME IS NOT NULL AND :NAME_ IS NOT NULL) AND
                           (UPPER (NAME) = UPPER (:NAME_))
                          )
                       OR (NAME IS NULL AND :NAME_ IS NULL)
                      )

                  AND (
                          (
                           (ITFFIELDNAME IS NOT NULL AND :ITFFIELDNAME_ IS NOT NULL) AND
                           (UPPER (ITFFIELDNAME) = UPPER (:ITFFIELDNAME_))
                          )
                       OR (ITFFIELDNAME IS NULL AND :ITFFIELDNAME_ IS NULL)
                      )

                  AND (
                          (
                           (NOTE IS NOT NULL AND :NOTE_ IS NOT NULL) AND
                           (UPPER (NOTE) = UPPER (:NOTE_))
                          )
                       OR (NOTE IS NULL AND :NOTE_ IS NULL)
                      )
                  AND (UPPER (TEMPLATEFIELD) = UPPER (:TEMPLATEFIELD_))
                  AND (
                          (
                           (ISBUDGET IS NOT NULL AND :ISBUDGET_ IS NOT NULL) AND
                           (ISBUDGET = :ISBUDGET_)
                          )
                       OR (ISBUDGET IS NULL AND :ISBUDGET_ IS NULL)
                      )
                  AND (
                          (
                           (FIELDINFOREF IS NOT NULL AND :FIELDINFOREF_ IS NOT NULL) AND
                           (FIELDINFOREF = :FIELDINFOREF_)
                          )
                       OR (FIELDINFOREF IS NULL AND :FIELDINFOREF_ IS NULL)
                      )
                  AND (
                          (
                           (CONTAINERREF IS NOT NULL AND :CONTAINERREF_ IS NOT NULL) AND
                           (CONTAINERREF = :CONTAINERREF_)
                          )
                       OR (CONTAINERREF IS NULL AND :CONTAINERREF_ IS NULL)
                      )   
                  AND (
                          (
                           (ATTRFIELDKIND IS NOT NULL AND :ATTRFIELDKIND_ IS NOT NULL) AND
                           (ATTRFIELDKIND = :ATTRFIELDKIND_)
                          )
                       OR (ATTRFIELDKIND IS NULL AND :ATTRFIELDKIND_ IS NULL)
                      )
                  AND (
                          (
                           (ATTRIBUTENAME IS NOT NULL AND :ATTRIBUTENAME_ IS NOT NULL) AND
                           (UPPER (ATTRIBUTENAME) = UPPER (:ATTRIBUTENAME_))
                          )
                       OR (ATTRIBUTENAME IS NULL AND :ATTRIBUTENAME_ IS NULL)
                      )                                               
                  AND (DOCTYPEREF = :DOCTYPEREF_)
                  AND (DETAILNUMBER = :DETAILNUMBER_)
                  AND (ONLYREAD = :ONLYREAD_)
                  AND (
                          (
                           (ReportFieldName IS NOT NULL AND :ReportFieldName_ IS NOT NULL) AND
                           (UPPER (ReportFieldName) = UPPER (:ReportFieldName_))
                          )
                       OR (ReportFieldName IS NULL AND :ReportFieldName_ IS NULL)
                      )
                 );
   ELSE
      INSERT INTO DocumentFields
                  (ID, NAME, ITFFIELDNAME, NOTE, TEMPLATEFIELD,
                   ISBUDGET, DOCTYPEREF, DETAILNUMBER, ONLYREAD,ReportFieldName, FIELDINFOREF, ContainerRef, AttrFieldKind, AttributeName
                  )
           VALUES (:ID_, :NAME_, :ITFFIELDNAME_, :NOTE_, :TEMPLATEFIELD_,
                   :ISBUDGET_, :DOCTYPEREF_, :DETAILNUMBER_, :ONLYREAD_, :ReportFieldName_, :FIELDINFOREF_, :ContainerRef_, :AttrFieldKind_, :AttributeName_
                  );

   FOR SELECT ID
            FROM DocumentFields
           WHERE (ID <> :ID_)
             AND (DOCTYPEREF = :DOCTYPEREF_)
             AND (
                     (
                      (ISBUDGET IS NOT NULL AND :ISBUDGET_ IS NOT NULL) AND
                      (ISBUDGET = :ISBUDGET_)
                     )
                  OR (ISBUDGET IS NULL AND :ISBUDGET_ IS NULL)
                 )
             AND (DETAILNUMBER = :DETAILNUMBER_)
             AND ( /*     ,      ,       */
                    (
                      ((:ITFFIELDNAME_ IS NULL)or(:ITFFIELDNAME_=' ')or (:ITFFIELDNAME_=''))
                      and not((:TEMPLATEFIELD_ IS NULL)or(:TEMPLATEFIELD_='')or(:TEMPLATEFIELD_=' '))
                      and(TEMPLATEFIELD is not null) and (UPPER(TEMPLATEFIELD)=UPPER(:TEMPLATEFIELD_))
                    )
                 or (
                       not ((:ITFFIELDNAME_ IS NULL) or (:ITFFIELDNAME_=' ') or (:ITFFIELDNAME_=''))
                       and (ITFFIELDNAME IS not NULL) and (UPPER(ITFFIELDNAME)=UPPER(:ITFFIELDNAME_))
                    )
                 )
            INTO :FieldID
   DO BEGIN
      UPDATE State_OpenFields
         SET DOCFIELDREF = :ID_
       WHERE (DOCFIELDREF = :FieldID);

      UPDATE DOCLOCKFIELDS
         SET FIELDREF = :ID_
       WHERE (FIELDREF = :FieldID);

      UPDATE staticlinks
         SET PARENTFIELDREF = :ID_
      WHERE (PARENTFIELDREF = :FieldID);

      UPDATE staticlinks
         SET CHILDFIELDREF = :ID_
      WHERE (CHILDFIELDREF = :FieldID);

      DELETE FROM DocumentFields
            WHERE (ID = :FieldID);
   END
END
!!

CREATE PROCEDURE DeleteFields (ID_ INTEGER) AS
BEGIN
  DELETE FROM State_OpenFields
  WHERE (docfieldref = :ID_);
  DELETE FROM DOCLOCKFIELDS
  WHERE (fieldref = :ID_);

  DELETE FROM STATE_JUMPCONTROL
  WHERE STATICLINKREF IN(SELECT ID FROM staticlinks
                           WHERE (PARENTFIELDREF=:ID_)OR(CHILDFIELDREF=:ID_));
  DELETE FROM staticlinks
  WHERE (PARENTFIELDREF=:ID_)OR(CHILDFIELDREF=:ID_);

  DELETE FROM DOCUMENTTEMPLATEFIELDS
  WHERE (FIELDS=:ID_);
  
  DELETE FROM STOREDATTRIBUTESDETAIL
  WHERE (ATTRIBUTEFIELD = :ID_) or (CONTAINERFIELD = :ID_);  

  DELETE FROM DocumentFields
  WHERE (id = :ID_);
END
!!

CREATE PROCEDURE INSERTCONST (
  PROGINDEX_     INTEGER,
  CONSTINDEX_    INTEGER,
  CONSTTYPE_     INTEGER,
  NOTE_          VARCHAR(255),
  VARCHARVALUE_  VARCHAR(255),
  DOUBLEVALUE_   Double precision,
  INTVALUE_      INTEGER,
  EditDocCode_   INTEGER
) AS
DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  IF (:CONSTTYPE_ = 3) THEN
  BEGIN
    SELECT COUNT (PROGINDEX)
    FROM IntConst
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_)
    INTO IDExists;

    IF (:IDExists = 0) THEN
      INSERT INTO INTCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (:PROGINDEX_,:CONSTINDEX_,:INTVALUE_,:NOTE_,:EDITDOCCODE_);
    ELSE 
      UPDATE INTCONST SET
        NOTE = :NOTE_,
        EDITDOCCODE = :EDITDOCCODE_
      WHERE (PROGINDEX=:PROGINDEX_) AND (CONSTINDEX=:CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 8) THEN
  BEGIN
    SELECT COUNT (PROGINDEX)
    FROM VarcharConst
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_)
    INTO IDExists;

    IF (:IDExists = 0) THEN
      INSERT INTO VARCHARCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (:PROGINDEX_,:CONSTINDEX_,:VARCHARVALUE_,:NOTE_,:EDITDOCCODE_);
    ELSE 
      UPDATE VARCHARCONST SET
        NOTE = :NOTE_,
        EDITDOCCODE = :EDITDOCCODE_
      WHERE (PROGINDEX=:PROGINDEX_) AND (CONSTINDEX=:CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 5) THEN
  BEGIN
    SELECT COUNT (PROGINDEX)
    FROM RealConst
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_)
    INTO IDExists;

    IF (:IDExists = 0) THEN
      INSERT INTO REALCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (:PROGINDEX_,:CONSTINDEX_,:DOUBLEVALUE_,:NOTE_,:EDITDOCCODE_);
    ELSE 
      UPDATE REALCONST SET
        NOTE = :NOTE_,
        EDITDOCCODE = :EDITDOCCODE_
      WHERE (PROGINDEX=:PROGINDEX_) AND (CONSTINDEX=:CONSTINDEX_);
  END
END
!!

CREATE PROCEDURE DELETECONST (
  PROGINDEX_     INTEGER,
  CONSTINDEX_    INTEGER,
  CONSTTYPE_     INTEGER
) AS
DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  IF (:CONSTTYPE_ = 3) THEN
  BEGIN
    UPDATE IntConst
      SET CloseDate = 'NOW'
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 8) THEN
  BEGIN
    UPDATE VARCHARCONST
      SET CloseDate = 'NOW'
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 5) THEN
  BEGIN
    UPDATE REALCONST
      SET CloseDate = 'NOW'
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_);
  END
END
!!

/*        */
ALTER TRIGGER TR_INTCONST_BU_500 INACTIVE
!!
ALTER TRIGGER TR_VARCHARCONST_BU_500 INACTIVE
!!
ALTER TRIGGER TR_REALCONST_BU_500 INACTIVE
!!


/*    , +(2) */
EXECUTE PROCEDURE ImportField(21610001, '()', 'CREATERUSER', '()', 'CREATERUSER_Cpt', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610003, '  ()', 'CREATEDATE', '  ()', ' ', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610004, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610005, ' ', 'Id', ' ', 'Id', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610006, ' ', 'Note1', ' ', 'Note1', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610007, '', 'BudgetRef', '', 'BudgetRef', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610008, '', 'Variant', '', 'Variant', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610009, '', 'Number', '', 'Number', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610010, ' ', 'DateInput', ' ', 'DateInput', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610011, '  ()', 'OrgRef', '  ()', 'DestOrgRef', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610012, '  ', 'RejectCls', '  ', 'RejectCls', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610013, '  ()', 'RejectCause', '  ()', 'RejectCause', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610014, ' ', 'CryptoStatus', ' ', 'CryptoStatus', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610015, '', 'DocStateRef', '', 'DocStateRef', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610016, '  ', 'SenderId', '  ', 'SenderId', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610017, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610018, '  ', 'SenderRecordID', '  ', 'SenderRecordID', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610019, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610056, ' ', 'PlanDocType', ' ', 'PlanDocType', 2, 216, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610057, ' ', 'Dat', ' ', 'Dat', 2, 216, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611002, '()', 'CREATERUSER', '()', 'CREATERUSER_Det', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611020, ' ', 'ClsType', ' ', 'ClsType', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611021, ' ', 'SUMMAYEAR1', ' ', 'SUMMAYEAR1', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611022, '', 'TreeOwner0', ' ()', ' ', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611023, ' 1', 'Quarter1', ' 1', 'Quarter1', 2, 216, 1, 0, '1', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611024, ' 2', 'Quarter2', ' 2', 'Quarter2', 2, 216, 1, 0, '2', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611025, ' 3', 'Quarter3', ' 3', 'Quarter3', 2, 216, 1, 0, '3', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611026, ' 4', 'Quarter4', ' 4', 'Quarter4', 2, 216, 1, 0, '4', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611027, '', 'Month01', '', 'Month01', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611028, '', 'Month02', '', 'Month02', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611029, '', 'Month03', '', 'Month03', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611030, '', 'Month04', '', 'Month04', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611031, '', 'Month05', '', 'Month05', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611032, '', 'Month06', '', 'Month06', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611033, '', 'Month07', '', 'Month07', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611034, '', 'Month08', '', 'Month08', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611035, '', 'Month09', '', 'Month09', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611036, '', 'Month10', '', 'Month10', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611037, '', 'Month11', '', 'Month11', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611038, '', 'Month12', '', 'Month12', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611039, '  ', 'SenderRecordId', '  ', 'SenderRecordId', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611040, '  ', 'SenderId', '  ', 'SenderId', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611041, ' ', 'RecordIndex', ' ', 'RecordIndex', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611042, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611043, '', 'KVSR', '()', 'DestKvsrKey', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611044, '()', 'KVSRCode', '()', 'DestKvsr', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611045, '()', 'KFSR', '()', 'DestKfsr', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611046, '', 'KVR', '()', 'DestKvrKey', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611047, '()', 'KVRCode', '()', 'DestKvr', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611048, '', 'KCSR', '()', 'DestKcsrKey', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611049, '()', 'KCSRCode', '()', 'DestKcsr', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611050, '', 'Org_Ref', '', 'Org_Ref_Det', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611051, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 2, 216, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611052, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611053, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611057, '', 'KD', '', 'KD', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611058, ' .  . . ()', 'IFS', ' ', 'IFS', 2, 216, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21611059, '', 'Note', '', 'Note', 2, 216, 1, 1, '', 0, 17431, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21610058, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 216, 0, 0, '', 0, null, 0, 2, '') !!
EXECUTE PROCEDURE ImportField(21611060, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 216, 1, 0, '', 0, null, 0, 2, '') !!
/*    , (1) */
EXECUTE PROCEDURE ImportField(21711032, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711033, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711034, '()', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711035, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711039, '()', 'INN', '()', 'DestFacialAccClsOrgINN', 1, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711040, '()', 'INN20', '()', 'DestFacialAccClsOrgKPP', 1, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711043, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711044, '()', 'KDKVSRCode', '()', 'KDKVSRCode', 1, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711045, ' ', 'KDValue', ' ', 'KDValue', 1, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711054, '()', 'NAME', '()', 'DestFacialAccClsOrgName', 1, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711055, '', 'OrgNameAndAcc', '', ' ', 1, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712060, ' ()', 'IFS_DescriptionCode', ' ()', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712061, '()', 'IFS_KVSRCode', '()', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712062, '()', 'IFSAGCode', '()', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712069, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712070, ' ()', 'KDKVSRCode', ' ()', 'KDKVSRCode', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712071, ' ', 'KDValue', ' ', 'KDValue', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712079, '', 'OrgNameAndAcc', '', ' ', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712081, ' ()', 'ProgramCode', ' ()', 'ProgramCode', 1, 217, 2, 1, '', 0, null, 0, 0, '') !!
/*    , +(2) */
EXECUTE PROCEDURE ImportField(21710001, '  ()', 'CREATEDATE', '  ()', ' ', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710002, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710003, '', 'BudgetRef', '', 'BudgetRef', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710004, ' ', 'ClsType', ' ', ' ', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710005, ' ', 'Dat', ' ', 'Dat', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710006, ' ', 'DateInput', ' ', 'DateInput', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710007, '', 'DocStateRef', ' ', 'DocStateRef', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710008, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710009, ' ', 'ID', ' ', 'ID', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710010, ' ', 'Note1', ' ', 'Note1', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710011, ' ', 'Number', ' ', 'Number', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710012, ' ', 'OrgRef', ' ', 'DestOrgRef', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710013, ' ', 'OrgName', ' ', 'DestOrgName', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710014, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710015, '  ()', 'RejectCause', '  ()', 'RejectCause', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710016, '  ', 'RejectCls', '  ', 'RejectCls', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710017, '', 'Variant', '', 'Variant', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710021, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710022, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710023, '', 'KPPeriod', '', 'KPPeriod', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710024, '  ', 'SenderId', '  ', 'SenderId', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710025, '  ', 'SenderRecordID', '  ', 'SenderRecordID', 2, 217, 0, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710082, ' ', 'PlanDocType', ' ', 'PlanDocType', 2, 217, 0, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711026, ' ', 'ClsType', ' ', 'ClsType', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711027, '', 'DayPlan', '', 'DayPlan', 2, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711028, '', 'DayPlanSumma', '', 'DayPlanSumma', 2, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711029, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711030, ' ', 'Id', ' ', 'Id', 2, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711031, ' .  . . ()', 'IFS', '()', 'IFS', 2, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711041, '()', 'KCSRCode', '()', 'DestKcsr', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711042, '', 'KD', '', 'KD', 2, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711046, '()', 'KESRCODE', '()', 'DestKesr', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711047, '()', 'KFSR', '()', 'DestKfsr', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711048, '()', 'KVRCode', '()', 'DestKvr', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711049, '()', 'KVSRCode', '()', 'DestKvsr', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711050, '  ', 'RecordIndex', '  ', 'RecordIndex', 2, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711051, '', 'TreeOwner0', '', ' ', 2, 217, 1, 0, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712056, ' ', 'ClsType', ' ', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712057, ' ', 'FacialAcc_Cls', ' ', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712058, '/ ', 'FacialCode', '/ ', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712059, ' .  . . ()', 'IFS', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712064, '()', 'INN', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712065, '()', 'INN20', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712066, '', 'KCSR', ' ()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712067, '()', 'KCSRCode', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712068, '', 'KD', '', 'KD', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712072, '', 'KESR', ' ()', 'DestKesrKey', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712073, '()', 'KESRCODE', '()', 'DestKesr', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712074, '()', 'KFSR', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712075, '', 'KVR', ' ()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712076, '()', 'KVRCode', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712077, '', 'KVSR', ' ()', 'DestKvsrKey', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712078, '()', 'KVSRCode', '()', ' ', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21711052, '', 'Note', '', 'Note', 2, 217, 1, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21712082, '', 'Note', '', 'Note', 2, 217, 2, 1, '', 0, null, 0, 0, '') !!
EXECUTE PROCEDURE ImportField(21710083, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 217, 0, 0, '', 0, null, 0, 2, '') !!
EXECUTE PROCEDURE ImportField(21711053, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 217, 1, 0, '', 0, null, 0, 2, '') !!
EXECUTE PROCEDURE ImportField(21712083, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 217, 2, 0, '', 0, null, 0, 2, '') !!

/*        */
ALTER TRIGGER TR_INTCONST_BU_500 ACTIVE
!!
ALTER TRIGGER TR_VARCHARCONST_BU_500 ACTIVE
!!
ALTER TRIGGER TR_REALCONST_BU_500 ACTIVE
!!

DROP PROCEDURE ImportField !!
DROP PROCEDURE DeleteFields !!
DROP PROCEDURE InsertConst !!
DROP PROCEDURE DELETECONST !!



CREATE PROCEDURE STATICLINK_DELETE(ID INTEGER) AS
BEGIN
  DELETE FROM STATICLINKS SL
  WHERE SL.ID = :ID;
END
!!

CREATE PROCEDURE STATICLINK_IMPORT(
  ID             INTEGER,
  NAME           VARCHAR(255),
  PARENTFIELDREF INTEGER,
  CHILDFIELDREF  INTEGER,
  LINKKIND      INTEGER,
  ParentDelAction INTEGER
) AS
DECLARE VARIABLE FINDID INTEGER;
BEGIN
  /*    ID,    CHILDFIELDREF,PARENTFIELDREF. 
   ,     ,    ID.       ID  , 
   (  )     id ,      */
  FINDID = NULL;
  SELECT
    SL.ID
  FROM 
    STATICLINKS SL
  WHERE (SL.CHILDFIELDREF = :CHILDFIELDREF) AND (SL.PARENTFIELDREF = :PARENTFIELDREF) AND (SL.ID <> :ID)
  INTO :FINDID;
  
  IF (:FINDID IS NOT NULL) THEN
  BEGIN
    /*  ID         */
    IF  (EXISTS (
        SELECT ID FROM STATE_JUMPCONTROL
        WHERE (STATICLINKREF = :FINDID ))) 
    THEN   
    BEGIN
      IF (NOT EXISTS (
        SELECT ID FROM STATICLINKS SL
      WHERE SL.ID = :ID )) THEN
      INSERT INTO STATICLINKS
        (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
      VALUES
        (:ID,:NAME,:CHILDFIELDREF,:PARENTFIELDREF,1,:ParentDelAction); /*  ,       */
        
      UPDATE STATE_JUMPCONTROL
        SET STATICLINKREF = :ID
      WHERE (STATICLINKREF = :FINDID);

      DELETE FROM STATICLINKS  
      WHERE ID=:FINDID;
        
    END
    ELSE   
      IF (NOT EXISTS (
        SELECT ID FROM STATICLINKS SL
        WHERE SL.ID = :ID )) THEN
      begin
        UPDATE STATICLINKS
        SET ID=:ID
        WHERE ID=:FINDID;
      end
      else
        DELETE FROM STATICLINKS
        WHERE ID=:FINDID;
    
  END /* id  */

  /*      ( ), 
   ,            CHILDFIELDREF.
   ,        1( )*/
  IF (:LINKKIND=0) THEN
    UPDATE STATICLINKS
    SET LINKKIND=1  
    WHERE (CHILDFIELDREF = :CHILDFIELDREF) AND (ID <> :ID) AND (LINKKIND=0);
  
  /*       id.  ,   .  ,   */
  
  IF (EXISTS (
    SELECT ID FROM STATICLINKS SL
    WHERE SL.ID = :ID )) THEN
  BEGIN
    UPDATE STATICLINKS SET
      NAME           = :NAME,
      PARENTFIELDREF = :PARENTFIELDREF,
      CHILDFIELDREF  = :CHILDFIELDREF,
      LINKKIND       = :LINKKIND,
      ParentDelAction = :ParentDelAction
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO STATICLINKS
      (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
    VALUES
      (:ID,:NAME,:PARENTFIELDREF,:CHILDFIELDREF,:LINKKIND,:ParentDelAction);
  END
END
!!

/*   */
EXECUTE PROCEDURE STATICLINK_IMPORT(990238700,'.BUDGETREF()->.ID',987810006,21610007,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(960205100,'.ORGREF()->.ID',960110033,21610011,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990238800,'.REJECTCLS()->.ID',985010005,21610012,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980233100,'.FACIALACCCLS()->.ID',984110021,21610017,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(20203100,'.1.RECORDINDEX()->.ID()',21610005,21611041,0,2) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980233000,'.1.FACIALACC_CLS()->.ID',984110021,21611042,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980232700,'.1.KVSR()->.ID',980310002,21611043,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980232800,'.1.KFSR()->.ID',980210004,21611045,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980232600,'.1.KVR()->.ID',980410002,21611046,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980232900,'.1.KCSR()->.ID',980510002,21611048,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(960205000,'.1.ORG_REF()->.ID',960110033,21611050,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990239100,'.BUDGETREF()->.ID',987810006,21710003,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980233400,'.FACIALACCCLS()->.ID',984110021,21710008,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(960205200,'.ORGREF()->.ID',960110033,21710012,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990239000,'.REJECTCLS()->.ID',985010005,21710016,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980233300,'.1.KD()->.ID',980910006,21711042,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(20203200,'.1.RECORDINDEX()->.ID()',21610005,21711050,0,2) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980233500,'.2.FACIALACC_CLS()->.ID',984110021,21712057,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990238600,'.PLANDOCTYPE()->.ID',986410002,21610056,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990239200,'.PLANDOCTYPE()->.ID',988410002,21710082,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(980233200,'.1.KD()->.ID',980910006,21611057,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990238900,'.1.IFS()->.ID',985210008,21611058,0,0) !!

DROP PROCEDURE STATICLINK_DELETE !!
DROP PROCEDURE STATICLINK_IMPORT !!

CREATE PROCEDURE FILTERS_DELETE(ID INTEGER) AS
BEGIN
  DELETE FROM STATE_JUMPCONTROL
  WHERE STATE_JUMPCONTROL.FILTERCODE = :ID;
  UPDATE STATE_ACTIONJUMPS SAJ
  SET SAJ.FILTERCODE = NULL, SAJ.OPTIONS = NULL
  WHERE SAJ.FILTERCODE = :ID;
  DELETE FROM State_Filter SF
  WHERE SF.ID = :ID;
END
!!

CREATE PROCEDURE FILTERS_IMPORT(
  ID integer,
  Name Varchar(255),
  Note Varchar(255),
  FilterValue Varchar(1024),
  FilterFormat integer,
  FilterActive integer,
  IsBudget integer
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM State_Filter
    WHERE State_Filter.ID = :ID ))
  THEN
  BEGIN
    UPDATE State_Filter SET
      NAME = :NAME,
      Note = :Note,
      FilterValue = :FilterValue,
      FilterFormat = :FilterFormat,
      FilterActive = :FilterActive,
      IsBudget = :IsBudget
    WHERE ID = :ID;
  END
  ELSE
  BEGIN
    INSERT INTO State_Filter
      (ID,NAME,Note,FilterValue,FilterFormat,IsBudget,FilterActive)
    VALUES
      (:ID,:NAME,:Note,:FilterValue,:FilterFormat,:IsBudget,:FilterActive);
  END
END
!!

CREATE PROCEDURE FILTERS_IMPORTURM(
  ID integer,
  Name Varchar(255),
  Note Varchar(255),
  FilterValueURM Varchar(1024),
  FilterFormat integer,
  FilterActive integer,
  IsBudget integer
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM State_Filter
    WHERE State_Filter.ID = :ID ))
  THEN
  BEGIN
    UPDATE State_Filter SET
      NAME = :NAME,
      Note = :Note,
      FilterValueURM = :FilterValueURM,
      FilterFormat = :FilterFormat,
      FilterActive = :FilterActive,
      IsBudget = :IsBudget
    WHERE ID = :ID;
  END
  ELSE
  BEGIN
    INSERT INTO State_Filter
      (ID,NAME,Note,FilterValueURM,FilterFormat,IsBudget,FilterActive)
    VALUES
      (:ID,:NAME,:Note,:FilterValueURM,:FilterFormat,:IsBudget,:FilterActive);
  END
END
!!

/*  */

DROP PROCEDURE FILTERS_DELETE !!
DROP PROCEDURE FILTERS_IMPORT !!
DROP PROCEDURE FILTERS_IMPORTURM !!

CREATE PROCEDURE STATUSICONS_IMPORT(
  ID INTEGER,
  NOTE VARCHAR(255),
  DOCREF INTEGER,
  DETAILNUM INTEGER,
  ICONNAME VARCHAR(255),
  ISSYSTEM INTEGER,
  ICONPOS INTEGER,
  RUNPOS INTEGER,
  RESERVEPOS INTEGER,
  ICONHINT VARCHAR(255),
  ICONKIND INTEGER,
  LOCKMASK INTEGER,
  FORMULA VARCHAR(1024),
  ISBUDGET INTEGER
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM STATUSICONS SI
    WHERE SI.ID = :ID ))
  THEN
  BEGIN
    UPDATE STATUSICONS SET
      NOTE = :NOTE,
      DOCREF = :DOCREF,
      DETAILNUM = :DETAILNUM,
      ICONNAME = :ICONNAME,
      ISSYSTEM = :ISSYSTEM,
      ICONPOS = :ICONPOS,
      RUNPOS = :RUNPOS,
      RESERVEPOS = :RESERVEPOS,
      ICONHINT = :ICONHINT,
      ICONKIND = :ICONKIND,
      LOCKMASK = :LOCKMASK,
      FORMULA = :FORMULA,
      ISBUDGET = :ISBUDGET
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO STATUSICONS
      (ID, NOTE, DOCREF, DETAILNUM, ICONNAME, ISSYSTEM, ICONPOS, RUNPOS, RESERVEPOS, ICONHINT, ICONKIND, LOCKMASK, FORMULA, ISBUDGET)
    VALUES
      (:ID, :NOTE, :DOCREF, :DETAILNUM, :ICONNAME, :ISSYSTEM, :ICONPOS, :RUNPOS, :RESERVEPOS, :ICONHINT, :ICONKIND, :LOCKMASK, :FORMULA, :ISBUDGET);
  END
END
!!

CREATE PROCEDURE STATUSICONS_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM STATUSICONS SI
  WHERE SI.ID = :ID;
END
!!

/*   */
EXECUTE PROCEDURE STATUSICONS_DELETE(45093) !!

DROP PROCEDURE STATUSICONS_IMPORT !!
DROP PROCEDURE STATUSICONS_DELETE !!


CREATE PROCEDURE ENUMS_IMPORT(NAME VARCHAR(255),FACIALACCCLS INTEGER) AS
  DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  SELECT COUNT(ID) FROM ENUMS WHERE NAME = :NAME INTO :IDEXISTS;
  IF (:IDEXISTS > 1) THEN
      DELETE FROM ENUMS E1
      WHERE (E1.NAME = :NAME) AND (E1.ID > (SELECT MIN(E2.ID) FROM ENUMS E2 WHERE E2.NAME = :NAME));
  IF (:IDEXISTS > 0) THEN
    UPDATE ENUMS SET
      FACIALACCCLS = :FACIALACCCLS,
      ISSYSTEM = 1
    WHERE NAME = :NAME;
  ELSE
    INSERT INTO ENUMS
      (NAME,FACIALACCCLS,ISSYSTEM)    
    VALUES
      (:NAME,:FACIALACCCLS,1);
END
!!

CREATE PROCEDURE ENUMVALUES_IMPORT(ENUMNAME VARCHAR(255),NAME VARCHAR(1024),VAL INTEGER) AS
  DECLARE VARIABLE IDENUM INTEGER;
  DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  SELECT ID FROM ENUMS WHERE NAME = :ENUMNAME INTO :IDENUM;
  IF (:IDENUM IS NOT NULL) THEN
  BEGIN
    SELECT COUNT(ID) FROM ENUMVALUES WHERE ENUMREF = :IDENUM AND VAL = :VAL INTO :IDEXISTS;
    IF (:IDEXISTS > 1) THEN
      DELETE FROM ENUMVALUES EV1
      WHERE (EV1.ENUMREF = :IDENUM) AND (EV1.VAL = :VAL) AND
        (EV1.ID > (SELECT MIN(EV2.ID) FROM ENUMVALUES EV2 WHERE EV2.ENUMREF = :IDENUM AND EV2.VAL = :VAL));
    IF (:IDEXISTS > 0) THEN
      UPDATE ENUMVALUES SET
        NAME = :NAME
      WHERE ENUMREF = :IDENUM AND VAL = :VAL;
    ELSE
      INSERT INTO ENUMVALUES
        (VAL,NAME,ENUMREF)  
      VALUES
        (:VAL,:NAME,:IDENUM);
  END  
END
!!

CREATE PROCEDURE ENUMS_DELETE(NAME VARCHAR(255)) AS
BEGIN
  DELETE FROM ENUMS WHERE NAME = :NAME;
END
!!

CREATE PROCEDURE ENUMVALUES_DELETE(ENUMNAME VARCHAR(255),VAL INTEGER) AS
  DECLARE VARIABLE IDENUM INTEGER;
BEGIN
  SELECT ID FROM ENUMS WHERE NAME = :ENUMNAME INTO :IDENUM;
  IF (:IDENUM IS NOT NULL) THEN
    DELETE FROM ENUMVALUES WHERE VAL = :VAL AND ENUMREF = :IDENUM;
END
!!

/*  */
EXECUTE PROCEDURE ENUMS_IMPORT('',null) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','  ',0) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','    ',1) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','01= ( ,     ,   ) - ',1) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','06=   - ,       (  ,   )',6) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','07=  (  ,   )',7) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','08= -  ()            (  ,     )',8) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','09= ( ,     ,   ) - ',9) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','10= ( ,     ,   ) - ,   ',10) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','11= ( ,     ,   ) - ,   ',11) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','12= ( ,     ,   ) -   () ',12) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','13= ( ,       ,     ,   ) - ',13) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','15=  (  ),  ,    ,            ,    - ',15) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','16=   -  (  ,   )',16) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','17=   -  (  ,   )',17) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','18=  ,   ,          ',18) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','19=   ,  ,         (  ,     )',19) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','20=  (  ),  ,           (  ,     )',20) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','23=     (  ,   )',23) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','24= - ,       ,  ,   ,        (  ,     )',24) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','27=  (  ),      ,     ,          ',27) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','28=   -     (  ,   )',28) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=     ,  ()          (,  )',1) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=         (,  )',3) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','= -   ',16) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=    /  ',17) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=     ,      /      ',19) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','= (  )         , , ,  ,   ,       ',29) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','= ',30) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=       ()',31) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=         ,        ',32) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=         ,        ',33) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=    , , ,  ,      ',34) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','=   -  ,    -',35) !!

DROP PROCEDURE ENUMS_IMPORT !!
DROP PROCEDURE ENUMVALUES_IMPORT !!
DROP PROCEDURE ENUMS_DELETE !!
DROP PROCEDURE ENUMVALUES_DELETE !!

COMMIT WORK!!

CREATE PROCEDURE DOCLOCK_IMPORT(
  NAME            VARCHAR(50),
  LOCKMASK        INTEGER,
  DOCREF          INTEGER,
  DETAILNUM       INTEGER,
  RUNPOS          INTEGER,
  LOCKACTION      INTEGER,
  USERIGHTS       INTEGER,
  FORMULA         VARCHAR(4000),
  FORDELETE       INTEGER,
  ISSYSTEM        INTEGER,
  NOTE            VARCHAR(512),
  FORINSERT       INTEGER,
  ValidateMessage VARCHAR(255),
  Validatelevel   INTEGER,
  ValidateFilter  VARCHAR(4000),
  ISBUDGET        INTEGER) as
DECLARE VARIABLE DOCLOCKID INTEGER;
BEGIN
   DOCLOCKID=0;
   SELECT ID
   FROM DOCLOCK
   WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
   INTO :DOCLOCKID;

   IF ((:DOCLOCKID<>0)and(:DOCLOCKID is not null)) THEN
     IF (ISSYSTEM = 3) THEN
       UPDATE DOCLOCK SET
         NAME = :NAME,
         LOCKMASK = :LOCKMASK,
         DOCREF = :DOCREF,
         DETAILNUM = :DETAILNUM,
         RUNPOS = :RUNPOS,
         LOCKACTION = :LOCKACTION,
         FORMULA = :FORMULA,
         FORDELETE = :FORDELETE,
         ISSYSTEM = :ISSYSTEM,
         NOTE = :NOTE,
         FORINSERT = :FORINSERT,
         VALIDATEMESSAGE = :VALIDATEMESSAGE,
         VALIDATELEVEL = :VALIDATELEVEL,
         VALIDATEFILTER = :VALIDATEFILTER,
         ISBUDGET = :ISBUDGET,
         USERIGHTS = :USERIGHTS
       WHERE ID = :DOCLOCKID;  
     ELSE
       UPDATE DOCLOCK SET
         NAME = :NAME,
         LOCKMASK = :LOCKMASK,
         DOCREF = :DOCREF,
         DETAILNUM = :DETAILNUM,
         RUNPOS = :RUNPOS,
         LOCKACTION = :LOCKACTION,
         FORMULA = :FORMULA,
         FORDELETE = :FORDELETE,
         ISSYSTEM = :ISSYSTEM,
         NOTE = :NOTE,
         FORINSERT = :FORINSERT,
         VALIDATEMESSAGE = :VALIDATEMESSAGE,
         VALIDATELEVEL = :VALIDATELEVEL,
         VALIDATEFILTER = :VALIDATEFILTER,
         ISBUDGET = :ISBUDGET
       WHERE ID = :DOCLOCKID;    
   ELSE 
     INSERT INTO DOCLOCK
         (ISBUDGET,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORMULA,FORDELETE,ISSYSTEM,NOTE,FORINSERT,VALIDATEMESSAGE,VALIDATELEVEL,VALIDATEFILTER)
      VALUES
         (:ISBUDGET,:NAME,:LOCKMASK,:DOCREF,:DETAILNUM,:RUNPOS,:LOCKACTION,:USERIGHTS,:FORMULA,:FORDELETE,:ISSYSTEM,:NOTE,:FORINSERT,:VALIDATEMESSAGE,:VALIDATELEVEL,:VALIDATEFILTER);
END
!!

CREATE PROCEDURE DOCLOCK_DELETE(NAME VARCHAR(50), DOCREF INTEGER, DETAILNUM INTEGER, ISBUDGET INTEGER) AS
DECLARE VARIABLE DOCLOCKID INTEGER;
BEGIN
    DOCLOCKID=0;
    SELECT ID
    FROM DOCLOCK
    WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
    INTO :DOCLOCKID; 
    
    IF ((:DOCLOCKID <> 0)and(:DOCLOCKID is not null)) THEN
    BEGIN
        DELETE FROM DOCLOCK
        WHERE ID = :DOCLOCKID;
    END           
END
!!

CREATE PROCEDURE DOCLOCKFIELDS_DELETE(NAME VARCHAR(50), DOCREF INTEGER, DETAILNUM INTEGER, CANCHANGEFIELDS INTEGER, ISBUDGET INTEGER) AS
DECLARE VARIABLE DOCLOCKID INTEGER;
BEGIN
   DOCLOCKID=0;
   SELECT ID
   FROM DOCLOCK
   WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
   INTO :DOCLOCKID;
   
   IF ((:DOCLOCKID <> 0)and(:DOCLOCKID is not null)) THEN
   BEGIN
      DELETE FROM DOCLOCKFIELDS
      WHERE (DOCLOCKREF = :DOCLOCKID) AND ((ISSYSTEM = 1) OR ((ISSYSTEM = 0) AND (:CANCHANGEFIELDS = 0) ));
   END
END
!!

/*      DocLockFields*/
CREATE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(NAME VARCHAR(50), DOCREF INTEGER, DETAILNUM INTEGER, FIELDREF INTEGER, ISBUDGET INTEGER) AS
DECLARE VARIABLE NID INTEGER;
DECLARE VARIABLE DOCLOCKFIELDID INTEGER;
BEGIN
  NID = 0;
  SELECT ID FROM DOCLOCK
  WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
  INTO :NID;
     
  IF ((:NID <> 0)and(:NID is not null)) THEN
  BEGIN
    DOCLOCKFIELDID = 0;
    SELECT ID FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = :NID) AND (FIELDREF = :FIELDREF)
    INTO :DOCLOCKFIELDID;
    IF (:DOCLOCKFIELDID = 0) THEN
      INSERT INTO DOCLOCKFIELDS
        (DOCLOCKREF,FIELDREF,ISSYSTEM)
      VALUES
        (:NID,:FIELDREF,1);
    ELSE
      UPDATE DOCLOCKFIELDS SET
        ISSYSTEM = 1
      WHERE ID = :DOCLOCKFIELDID;      
  END
END
!!

EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65536,216,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 216, -1, 0, 2) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',216,-1,21610013,2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',216,-1,21610012,2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',216,-1,21610057,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',65536,216,-1,0,7,0,'',1,1,'   .   ,   .           .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 216, -1, 0, 2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ,   ',65540,216,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ,   ', 216, -1, 1, 1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610007,1) !!
/*  " ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611051,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611050,1) !!
/*  "()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611049,1) !!
/*  "()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611047,1) !!
/*  "()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611045,1) !!
/*  "()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611044,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611042,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611038,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611037,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611036,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611035,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611034,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611033,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611032,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611031,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611030,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611029,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611028,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611027,1) !!
/*  " 4" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611026,1) !!
/*  " 3" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611025,1) !!
/*  " 2" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611024,1) !!
/*  " 1" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611023,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611022,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21611021,1) !!
/*  "\  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610017,1) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610013,1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610012,1) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610011,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610010,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610009,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610008,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',216,-1,21610057,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' .    ',131072,216,-1,0,7,0,'[21610006] = "1"',0,1,'     ',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' .    ', 216, -1, 0, 2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,216,0,0,4,2,'',0,1,'  .       ',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 216, 0, 0, 2) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610013,2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610012,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,216,0,0,4,2,'[21610056]<200',0,1,'  .        .',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 216, 0, 0, 2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610057,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,216,0,0,4,2,'[21610056]>=200',0,1,'  .       .',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 216, 0, 0, 2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',216,0,21610057,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',65536,217,-1,0,7,0,'',1,1,'   .   ,   .           .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 217, -1, 0, 2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65536,217,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 217, -1, 0, 2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',217,-1,21710005,2) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',217,-1,21710015,2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',217,-1,21710016,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ,   ',65540,217,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ,   ', 217, -1, 1, 1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710013,1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710016,1) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710015,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710011,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',217,-1,21710006,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,217,0,0,4,2,'',0,1,'  .       ',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 217, 0, 0, 2) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710015,2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710016,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,217,0,0,4,2,'[21710082]<200',0,1,'  .        .',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 217, 0, 0, 2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710005,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,217,0,0,4,2,'[21710082]>=200',0,1,'  .       .',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 217, 0, 0, 2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',217,0,21710005,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',32768,9903,0,0,5,0,'([990310083] is not null) and (([990310057] < 30200) or ([990310057] > 30299))',0,3,'  ,       .',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 9903, 0, 0, 1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310057,1) !!
/*  "E-mail " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310018,1) !!
/*  " Web-" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310019,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310076,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310020,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310060,1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310059,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310004,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',9903,0,990310021,1) !!

EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',0,216,-1,0,15,1,'',0,1,'',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 216, -1, 0, 2) !!
/*  ".   ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21611060,2) !!
/*  ".  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21610058,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',0,216,-1,0,12,0,'',0,3,'',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 216, -1, 0, 2) !!
/*  ".   ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21611060,2) !!
/*  ".  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',216,-1,21610058,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',0,217,-1,0,12,0,'',0,3,'',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 217, -1, 0, 2) !!
/*  ".   ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21712083,2) !!
/*  ".   ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21711053,2) !!
/*  ".  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21710083,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',0,217,-1,0,15,1,'',0,1,'',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 217, -1, 0, 2) !!
/*  ".   ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21712083,2) !!
/*  ".   ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21711053,2) !!
/*  ".  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('  ',217,-1,21710083,2) !!

DROP PROCEDURE DOCLOCKFIELDS_INSERTFIELD !!
DROP PROCEDURE DOCLOCKFIELDS_DELETE !!
DROP PROCEDURE DOCLOCK_DELETE !!
DROP PROCEDURE DOCLOCK_IMPORT !!

CREATE PROCEDURE SELECTIONS_IMPORT(
  ID INTEGER,
  KIND INTEGER,
  NAME VARCHAR(30),
  NOTE VARCHAR(255),
  READONLY INTEGER,
  USEINDOC INTEGER,
  TABLENAME VARCHAR(30),
  ALIAS VARCHAR(30),
  TABLECODE INTEGER,
  NEEDGROUPONDB INTEGER,
  NEEDDISTINCT INTEGER,
  MASTER INTEGER,
  DISCRIMVALUE VARCHAR(255),
  AVAILABLEINDEREF INTEGER,
  CACHETYPE INTEGER,
  FULLORMODINSREFRTIME INTEGER,
  DELETEREFRTIME INTEGER,
  FINDTIMEREFRESH INTEGER,
  ANNOTATION VARCHAR(1024),
  DEREFNAME VARCHAR(30),
  GroupID INTEGER,
  IsLogged INTEGER
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM SELECTIONS SL
    WHERE SL.ID = :ID ))
  THEN
  BEGIN
    UPDATE SELECTIONS SET
      KIND = :KIND,
      NAME = :NAME,
      NOTE = :NOTE,
      READONLY = :READONLY,
      USEINDOC = :USEINDOC,
      TABLENAME = :TABLENAME,
      ALIAS = :ALIAS,
      TABLECODE = :TABLECODE,    
      NEEDGROUPONDB = :NEEDGROUPONDB,
      NEEDDISTINCT = :NEEDDISTINCT,
      MASTER = :MASTER,
      DISCRIMVALUE = :DISCRIMVALUE,
      AVAILABLEINDEREF = :AVAILABLEINDEREF,
      CACHETYPE = :CACHETYPE,
      FULLORMODINSREFRTIME = :FULLORMODINSREFRTIME,
      DELETEREFRTIME = :DELETEREFRTIME,
      FINDTIMEREFRESH = :FINDTIMEREFRESH,
      ANNOTATION = :ANNOTATION,     
      DEREFNAME = :DEREFNAME,
      GroupID = :GroupID,
      IsLogged = :IsLogged       
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO SELECTIONS
      (ID, KIND, NAME, NOTE, READONLY, USEINDOC, TABLENAME, ALIAS, TABLECODE, NEEDGROUPONDB, NEEDDISTINCT, MASTER, DISCRIMVALUE,
      AVAILABLEINDEREF, CACHETYPE, FULLORMODINSREFRTIME, DELETEREFRTIME, FINDTIMEREFRESH, ANNOTATION, DEREFNAME, GroupID, IsLogged)
    VALUES
      (:ID, :KIND, :NAME, :NOTE, :READONLY, :USEINDOC, :TABLENAME, :ALIAS, :TABLECODE, :NEEDGROUPONDB, :NEEDDISTINCT, :MASTER, :DISCRIMVALUE,
      :AVAILABLEINDEREF, :CACHETYPE, :FULLORMODINSREFRTIME, :DELETEREFRTIME, :FINDTIMEREFRESH, :ANNOTATION, :DEREFNAME, :GroupID, :IsLogged);
  END
END
!!

CREATE PROCEDURE SELECTIONSDETAIL_IMPORT(
  ID INTEGER,
  SELECTIONREF INTEGER,
  TABLEREF INTEGER,
  ALIAS VARCHAR(30),
  JOINORDER INTEGER,
  JOINTYPE INTEGER,
  RELATIONTYPE INTEGER,
  JOINCONDITION VARCHAR(255),
  DONTUSETABLELIMITS INTEGER,
  LIMITNAMESLIST VARCHAR(255),
  QueryGroup INTEGER 
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM SELECTIONSDETAIL SLD
    WHERE SLD.ID = :ID ))
  THEN
  BEGIN
    UPDATE SELECTIONSDETAIL SET
      SELECTIONREF = :SELECTIONREF,
      TABLEREF = :TABLEREF,
      ALIAS = :ALIAS,
      JOINORDER = :JOINORDER,
      JOINTYPE = :JOINTYPE,
      RELATIONTYPE = :RELATIONTYPE,
      JOINCONDITION = :JOINCONDITION,
      DONTUSETABLELIMITS = :DONTUSETABLELIMITS,
      LIMITNAMESLIST = :LIMITNAMESLIST,
      QueryGroup = :QueryGroup
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO SELECTIONSDETAIL
      (ID, SELECTIONREF, TABLEREF, ALIAS, JOINORDER, JOINTYPE, RELATIONTYPE, JOINCONDITION, DONTUSETABLELIMITS, LIMITNAMESLIST, QueryGroup)
    VALUES
      (:ID, :SELECTIONREF, :TABLEREF, :ALIAS, :JOINORDER, :JOINTYPE, :RELATIONTYPE, :JOINCONDITION, :DONTUSETABLELIMITS, :LIMITNAMESLIST, :QueryGroup);
  END
END
!!

CREATE PROCEDURE FIELDSINFO_IMPORT(
  ID INTEGER,
  FIELDKIND INTEGER,
  DESCRIPTIONLEVEL INTEGER,
  ANCESTORREF INTEGER,
  SELECTIONREF INTEGER,
  TABLEREF INTEGER,
  FIELDNAME VARCHAR(50),
  DATATYPE INTEGER,
  SUBDATATYPE INTEGER,
  FIELDSIZE INTEGER,
  DISPLAYLABEL VARCHAR(80),
  NOTE VARCHAR(255),
  DEFAULTWIDTH INTEGER,
  EDITMASK VARCHAR(80),
  DISPLAYFORMAT VARCHAR(80),
  EDITFORMAT VARCHAR(80),
  CANTEDIT INTEGER,
  NOVISUALIZE INTEGER,
  ENUMSREF INTEGER,
  REQUIRED INTEGER,
  FOREIGNKEY INTEGER,
  ONDELACTION INTEGER,
  PRIMARYKEY INTEGER,
  ISRVERSION INTEGER,
  LIMITPARAMNAMES VARCHAR(255),
  FOLLOWORDER INTEGER,
  SORTDIRECTION INTEGER,
  SORTORDER INTEGER,
  AGRFUNCTION INTEGER,
  FLAGFIELDNAME INTEGER,
  FLAGDISPLAYLABEL INTEGER,
  FLAGNOTE INTEGER,
  FLAGDEFAULTWIDTH INTEGER,
  FLAGCANTEDIT INTEGER,
  FLAGNOVISUALIZE INTEGER,
  FLAGREQUIRED INTEGER,
  FLAGLIMITPARAMNAMES INTEGER,
  FLAGAGRFUNCTION INTEGER,
  ISTIMESTAMPFIELD INTEGER,
  ISBUDGET INTEGER,
  AVAILABLEINDEREF INTEGER,
  ANNOTATION VARCHAR(1024),
  ALIAS VARCHAR(30),
  DEREFNAME VARCHAR(30)
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM FIELDSINFO FI
    WHERE FI.ID = :ID ))
  THEN
  BEGIN
    UPDATE FIELDSINFO SET
      FIELDKIND = :FIELDKIND,
      DESCRIPTIONLEVEL = :DESCRIPTIONLEVEL,
      ANCESTORREF = :ANCESTORREF,
      SELECTIONREF = :SELECTIONREF,
      TABLEREF = :TABLEREF,
      FIELDNAME = :FIELDNAME,
      DATATYPE = :DATATYPE,
      SUBDATATYPE = :SUBDATATYPE,
      FIELDSIZE = :FIELDSIZE,
      DISPLAYLABEL = :DISPLAYLABEL,
      NOTE = :NOTE,
      DEFAULTWIDTH = :DEFAULTWIDTH,
      EDITMASK = :EDITMASK,
      DISPLAYFORMAT = :DISPLAYFORMAT,
      EDITFORMAT = :EDITFORMAT,
      CANTEDIT = :CANTEDIT,
      NOVISUALIZE = :NOVISUALIZE,
      ENUMSREF = :ENUMSREF,
      REQUIRED = :REQUIRED,
      FOREIGNKEY = :FOREIGNKEY,
      ONDELACTION = :ONDELACTION,
      PRIMARYKEY = :PRIMARYKEY,
      ISRVERSION = :ISRVERSION,
      LIMITPARAMNAMES = :LIMITPARAMNAMES,
      FOLLOWORDER = :FOLLOWORDER,
      SORTDIRECTION = :SORTDIRECTION,
      SORTORDER = :SORTORDER,
      AGRFUNCTION = :AGRFUNCTION,
      FLAGFIELDNAME = :FLAGFIELDNAME,
      FLAGDISPLAYLABEL = :FLAGDISPLAYLABEL,
      FLAGNOTE = :FLAGNOTE,
      FLAGDEFAULTWIDTH = :FLAGDEFAULTWIDTH,
      FLAGCANTEDIT = :FLAGCANTEDIT,
      FLAGNOVISUALIZE = :FLAGNOVISUALIZE,
      FLAGREQUIRED = :FLAGREQUIRED,
      FLAGLIMITPARAMNAMES = :FLAGLIMITPARAMNAMES,
      FLAGAGRFUNCTION = :FLAGAGRFUNCTION,
      ISTIMESTAMPFIELD = :ISTIMESTAMPFIELD,
      ISBUDGET = :ISBUDGET,
      AVAILABLEINDEREF = :AVAILABLEINDEREF,
      ANNOTATION = :ANNOTATION,
      ALIAS = :ALIAS,
      DEREFNAME = :DEREFNAME
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO FIELDSINFO
      (ID, FIELDKIND, DESCRIPTIONLEVEL, ANCESTORREF, SELECTIONREF, TABLEREF, FIELDNAME, DATATYPE, SUBDATATYPE,
       FIELDSIZE, DISPLAYLABEL, NOTE, DEFAULTWIDTH, EDITMASK, DISPLAYFORMAT, EDITFORMAT, CANTEDIT, NOVISUALIZE,
       ENUMSREF, REQUIRED, FOREIGNKEY, ONDELACTION, PRIMARYKEY, ISRVERSION, LIMITPARAMNAMES,
       FOLLOWORDER, SORTDIRECTION, SORTORDER, AGRFUNCTION, FLAGFIELDNAME, FLAGDISPLAYLABEL, FLAGNOTE,
       FLAGDEFAULTWIDTH, FLAGCANTEDIT, FLAGNOVISUALIZE, FLAGREQUIRED, FLAGLIMITPARAMNAMES, FLAGAGRFUNCTION,
       ISTIMESTAMPFIELD, ISBUDGET, AVAILABLEINDEREF, ANNOTATION, ALIAS, DEREFNAME)
    VALUES
      (:ID, :FIELDKIND, :DESCRIPTIONLEVEL, :ANCESTORREF, :SELECTIONREF, :TABLEREF, :FIELDNAME, :DATATYPE, :SUBDATATYPE,
       :FIELDSIZE, :DISPLAYLABEL, :NOTE, :DEFAULTWIDTH, :EDITMASK, :DISPLAYFORMAT, :EDITFORMAT, :CANTEDIT, :NOVISUALIZE,
       :ENUMSREF, :REQUIRED, :FOREIGNKEY, :ONDELACTION, :PRIMARYKEY, :ISRVERSION, :LIMITPARAMNAMES,
       :FOLLOWORDER, :SORTDIRECTION, :SORTORDER, :AGRFUNCTION, :FLAGFIELDNAME, :FLAGDISPLAYLABEL, :FLAGNOTE,
       :FLAGDEFAULTWIDTH, :FLAGCANTEDIT, :FLAGNOVISUALIZE, :FLAGREQUIRED, :FLAGLIMITPARAMNAMES, :FLAGAGRFUNCTION,
       :ISTIMESTAMPFIELD, :ISBUDGET, :AVAILABLEINDEREF, :ANNOTATION, :ALIAS, :DEREFNAME);
  END
END
!!

CREATE PROCEDURE SELECTIONEVENTS_IMPORT(
  ID INTEGER,
  SELECTIONREF INTEGER,
  EVENTCODE INTEGER,
  SCRIPTNAME VARCHAR(255)
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM SELECTIONEVENTS SE
    WHERE SE.ID = :ID ))
  THEN
  BEGIN
    UPDATE SELECTIONEVENTS SET
      SELECTIONREF = :SELECTIONREF,
      EVENTCODE = :EVENTCODE,
      SCRIPTNAME = :SCRIPTNAME
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO SELECTIONEVENTS
      (ID, SELECTIONREF, EVENTCODE, SCRIPTNAME)
    VALUES
      (:ID, :SELECTIONREF, :EVENTCODE, :SCRIPTNAME);
  END
END
!!

CREATE PROCEDURE FIELDSINFO_DELETE(
  ID INTEGER
) AS
BEGIN
  UPDATE DOCUMENTFIELDS SET
    FIELDINFOREF = NULL
  WHERE FIELDINFOREF = :ID;
  DELETE FROM FIELDSINFO FI
  WHERE FI.ID = :ID;
END
!!

CREATE PROCEDURE SELECTIONSDETAIL_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM SELECTIONSDETAIL SLD
  WHERE SLD.ID = :ID;
END
!!

CREATE PROCEDURE SELECTIONS_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM SELECTIONS SL
  WHERE SL.ID = :ID;
END
!!

CREATE PROCEDURE SELECTIONEVENTS_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM SELECTIONEVENTS SE
  WHERE SE.ID = :ID;
END
!!

/*  */
EXECUTE PROCEDURE SELECTIONS_IMPORT(35357, 1, 'CLSCORRESPONDENTS', '', 0, 0, 'CLSCORRESPONDENTS', 'CLSCORRESPONDENTS', 0, 0, 0, 2, '', 1, 1, 3600, -1, null, '', '', null, 0) !!
EXECUTE PROCEDURE SELECTIONS_IMPORT(45358, 2, '_', '', 0, 0, '', '', 0, 0, 0, 2, '', 1, 1, 600, null, 5, '', '', null, 0) !!
EXECUTE PROCEDURE SELECTIONSDETAIL_IMPORT(45359, 45358, 35357, 'CLSCORRESPONDENTS', 0, 0, 1, '', 0, '', 0) !!
/* _ */
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45372, 0, 2, 35361, 45358, 45359, 'ID', 3, 0, 0, ' ', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'ID', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45374, 0, 2, 35359, 45358, 45359, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CREATEDATE', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45376, 0, 2, 35360, 45358, 45359, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CREATERUSER', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45377, 0, 2, 35362, 45358, 45359, 'KESR', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 4, '', 'KESR', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45378, 0, 2, 35363, 45358, 45359, 'KVR', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 16864, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 4, '', 'KVR', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45379, 0, 2, 35364, 45358, 45359, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', 'UPDATEDATE', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45380, 0, 2, 35365, 45358, 45359, 'UPDATERUSER', 1, 0, 30, ' ', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'UPDATERUSER', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45381, 0, 2, 39250, 45358, 45359, 'KFSR', 3, 0, 0, '', '', 0, '', '', '', 0, 0, null, 1, 16844, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KFSR', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45382, 0, 2, 39251, 45358, 45359, 'CORRTYPE', 3, 0, 0, ' ', '', 0, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CORRTYPE', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45383, 0, 2, 39252, 45358, 45359, 'CORRBEL', 3, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'CORRBEL', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45384, 1, 2, null, 45358, null, 'KVRCODE', 1, 0, 3, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KVRCODE', '') !!
EXECUTE PROCEDURE FIELDSINFO_IMPORT(45385, 1, 2, null, 45358, null, 'KESRCODE', 1, 0, 3, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'KESRCODE', '') !!
/*   */
EXECUTE PROCEDURE SELECTIONEVENTS_IMPORT(45358, 45358, 3, '') !!

COMMIT WORK !!

DROP PROCEDURE SELECTIONS_IMPORT !!
DROP PROCEDURE SELECTIONSDETAIL_IMPORT !!
DROP PROCEDURE FIELDSINFO_IMPORT !!
DROP PROCEDURE SELECTIONEVENTS_IMPORT !!

DROP PROCEDURE FIELDSINFO_DELETE !!
DROP PROCEDURE SELECTIONSDETAIL_DELETE !!
DROP PROCEDURE SELECTIONS_DELETE !!
DROP PROCEDURE SELECTIONEVENTS_DELETE !!

COMMIT WORK!!


CREATE PROCEDURE LINKTYPE_IMPORT(
   ID                    INTEGER,     
   NAME                  VARCHAR(50),
   TEMPLATECLS           INTEGER, 
   PARENTDOCCLS          INTEGER,
   CHILDDOCCLS           INTEGER,
   LINKCOMMENT           VARCHAR(255),
   BLOCKPARENT           SMALLINT,
   BLOCKCHILD            SMALLINT,
   CANDELBLOCKPARENT     SMALLINT,
   CANDELBLOCKCHILD      SMALLINT,
   PARENTPICTURETYPE     INTEGER,
   PARENTPICTURENAME     VARCHAR(255),
   CHILDPICTURETYPE      INTEGER,
   CHILDPICTURENAME      VARCHAR(255),
   PICTURECOLLECTIONNAME VARCHAR(255),
   URMUSE                SMALLINT,
   DELMACROSNAME         VARCHAR(255),
   NEEDDELCHILD          SMALLINT,
   LINKKIND              SMALLINT 
) AS
DECLARE VARIABLE OLDID INTEGER;
BEGIN
   /*         ,     */
   /* ,   , ,  ,     */
   IF (((:TEMPLATECLS is not null)and(:TEMPLATECLS<>0))or((:NAME <> '')and(:Name is not null)))   
   THEN
     FOR SELECT id FROM LINKTYPE LT WHERE
         (id<>:ID)
         and(((:TEMPLATECLS is not null)and(:TEMPLATECLS<>0)and(LT.TEMPLATECLS = :TEMPLATECLS)
     and (LT.PARENTDOCCLS = :PARENTDOCCLS) and (LT.CHILDDOCCLS = :CHILDDOCCLS))
         or((:NAME <> '')and(:Name is not null)and(lt.Name=:Name)))
     INTO :OLDID do
     BEGIN
        /*            */    
        DELETE FROM LINKRECORDS WHERE LINKTYPEREF = -10;  
        DELETE FROM LINKTYPE WHERE ID = -10;
        DELETE FROM DOCUMENTCLS WHERE ID = -10;
        DELETE FROM DOCUMENTTYPES WHERE ID = -10;
        INSERT INTO DOCUMENTTYPES(ID, PROGINDEX) VALUES(-10, -10);
        INSERT INTO DOCUMENTCLS(ID, DOCTYPE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM)
           VALUES(-10, -10, '', '', '', '');
        INSERT INTO LINKTYPE(ID, PARENTDOCCLS, CHILDDOCCLS, NAME) VALUES(-10, -10, -10, '');

        UPDATE STATE_JUMPCONTROL SET
           REFERENCEREF = -10
        WHERE
           REFERENCEREF = :OLDID;
        UPDATE LINKRECORDS SET
           LINKTYPEREF = -10
        WHERE
           LINKTYPEREF = :OLDID;

        DELETE FROM LINKTYPE WHERE ID = :OLDID;
     END
   /*     */  
   IF (NOT EXISTS (SELECT * FROM LINKTYPE LT WHERE LT.ID = :ID))
   THEN
      INSERT INTO LINKTYPE
       (ID,NAME,TEMPLATECLS,PARENTDOCCLS, CHILDDOCCLS, LINKCOMMENT, BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,
        CANDELBLOCKCHILD,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,
        PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND)
      VALUES
       (:ID, :NAME, :TEMPLATECLS, :PARENTDOCCLS, :CHILDDOCCLS, :LINKCOMMENT, :BLOCKPARENT,:BLOCKCHILD,:CANDELBLOCKPARENT,
        :CANDELBLOCKCHILD, :PARENTPICTURETYPE,:PARENTPICTURENAME,:CHILDPICTURETYPE,:CHILDPICTURENAME,
        :PICTURECOLLECTIONNAME,:URMUSE,:DELMACROSNAME,:NEEDDELCHILD,:LINKKIND);
   ELSE
      UPDATE LINKTYPE SET
         NAME = :NAME,
         TEMPLATECLS = :TEMPLATECLS,
         PARENTDOCCLS = :PARENTDOCCLS,
         CHILDDOCCLS = :CHILDDOCCLS,
         LINKCOMMENT = :LINKCOMMENT,
         BLOCKPARENT = :BLOCKPARENT,
         BLOCKCHILD = :BLOCKCHILD,
         CANDELBLOCKPARENT = :CANDELBLOCKPARENT,
         CANDELBLOCKCHILD = :CANDELBLOCKCHILD,
         PARENTPICTURETYPE = :PARENTPICTURETYPE,
         PARENTPICTURENAME = :PARENTPICTURENAME,
         CHILDPICTURETYPE = :CHILDPICTURETYPE,
         CHILDPICTURENAME = :CHILDPICTURENAME,
         PICTURECOLLECTIONNAME = :PICTURECOLLECTIONNAME,
         URMUSE = :URMUSE,
         DELMACROSNAME = :DELMACROSNAME,
         NEEDDELCHILD = :NEEDDELCHILD,
         LINKKIND = :LINKKIND
      WHERE ID = :ID;
   /*     ,      */
   UPDATE STATE_JUMPCONTROL SET
     REFERENCEREF = :ID
   WHERE
     REFERENCEREF = -10;
   UPDATE LINKRECORDS SET
      LINKTYPEREF = :ID
   WHERE
      LINKTYPEREF = -10;
   /*  */  
   DELETE FROM LINKTYPE WHERE ID = -10;
   DELETE FROM DOCUMENTCLS WHERE ID = -10;
   DELETE FROM DOCUMENTTYPES WHERE ID = -10;
END
!!

/*   */
EXECUTE PROCEDURE LINKTYPE_IMPORT(20206000,'',null,20701,21601,'     ',1,0,0,0,1,'',1,'','1616',1,'',1,0) !!
EXECUTE PROCEDURE LINKTYPE_IMPORT(20206100,'',null,21101,21701,'     ',1,0,0,0,1,'',1,'','1616',0,'',1,0) !!
EXECUTE PROCEDURE LINKTYPE_IMPORT(30304300,'',null,30500,30500,'     ',0,0,1,1,1,'',1,'','',1,'',0,0) !!
EXECUTE PROCEDURE LINKTYPE_IMPORT(30304400,'',null,30501,30501,'     ',0,0,1,1,1,'',1,'','',1,'',0,0) !!
EXECUTE PROCEDURE LINKTYPE_IMPORT(90900700,'',null,90301,90301,'     ',0,0,1,1,1,'',1,'','',1,'',0,0) !!

COMMIT WORK !!

DROP PROCEDURE LINKTYPE_IMPORT !!

/*       */
INSERT INTO DFUCHANGELOG (VersionID, BEGINUPDATECODE, ENDUPDATECODE, LASTUPDATEDFU, ISBUDGET, INCLUDEDEL, INCLUDEBLOCKS, INCLUDEDOCS, SCRIPTCREATOR, SCRIPTCREATEDATE, NOTE) VALUES (3375, 131000, 132000, '13.10.2020 9:5:7', 1, 1, ',    ,  , ,  , ,  , , ', '00.00, 01.01, 02.00, 02.01, 02.02, 02.03, 02.04, 02.05, 02.06, 02.07, 02.08, 02.09, 02.10, 02.11, 02.12, 02.13, 02.14, 02.15, 02.16, 02.17, 03.00, 03.01, 03.02, 03.03, 03.04, 03.05, 03.06, 03.07, 03.08, 03.11, 03.12, 03.14, 03.15, 03.16, 03.22, 03.23, 03.24, 04.01, 05.01, 07.01, 07.02, 07.03, 08.01, 08.02, 08.03, 08.04, 09.00, 09.01, 09.02, 09.03, 09.05, 09.06, 09.07, 12.01, 15.01, 16.01, 16.02, 17.01, 17.02, 18.05, 18.07, 18.09, 18.10, 18.12, 18.13, 18.14, 18.15, 18.16, 18.18, 18.19, 18.20, 18.21, 19.00, 19.01, 19.02, 19.03, 19.06, 22.00, 22.01, 25.01, 25.02, 25.03, 25.04, 28.01, 28.02, 30.01, 30.02, 30.03, 30.04, 30.05, 30.06, 30.10, 30.11, 36.10, 37.01, 39.01, 44.01, 44.03, 47.01, 48.01, 49.01, 49.02, 49.03, 51.01, 52.01, 53.01, 53.02, 53.03, 53.04, 53.05, 53.06, 54.01, 54.02, 55.01, 55.02, 55.03, 96.01, 96.02, 96.03, 96.04, 97.01, 97.02, 97.09, 97.10, 98.02, 98.03, 98.04, 98.05, 98.06, 98.08, 98.09, 98.10, 98.11, 98.12, 98.13, 98.14, 98.15, 98.16, 98.17, 98.18, 98.20, 98.21, 98.22, 98.23, 98.26, 98.27, 98.28, 98.29, 98.34, 98.35, 98.41, 98.42, 98.43, 98.44, 98.45, 98.46, 98.47, 98.48, 98.49, 98.50, 98.51, 98.52, 98.53, 98.54, 98.57, 98.58, 98.59, 98.60, 98.61, 98.62, 98.63, 98.64, 98.65, 98.67, 98.68, 98.69, 98.70, 98.71, 98.72, 98.78, 98.79, 98.80, 98.81, 98.82, 98.83, 98.84, 98.85, 98.86, 98.87, 98.88, 98.89, 98.90, 98.91, 98.92, 98.94, 98.95, 98.97, 98.98, 98.99, 99.03, 99.04, 99.05, 99.08, 99.12, 99.13, 99.14, 99.15, 99.16, 99.17, 99.18, 99.19, 99.20, 99.21, 99.22, 99.23, 99.24, 99.25, 99.26, 99.27, 99.28, 99.29, 99.30, 99.31, 99.32', 'MCHEKUNOV/mchekunov', '31.12.2020 7:41:32', '') !!

COMMIT WORK!!

SET TERM ; !!